#!/usr/bin/env python
# from Pueblo opb format, generate cplex lp format to stdout
# argv[1]: the Pueblo opb format


import os
import sys
import string


def convertStr(s):
#"""Convert string to either int or float."""
	try:
		ret = int(s)
	except ValueError:
		#Try float.
		ret = float(s)
	return ret

def ReadOPB( InFileName ):
	VarSet = set()
	ConstraintSet = set()
	OBJ = ''
	OPBFile = open(InFileName, 'r')
	for opb_line in OPBFile:
		VarMap = {}
		line = opb_line.strip(';\n').strip()
		if len( line ) != 0:
			if line[0] != '*':
				split_line = line.split()
				split_line_idx = 0
				if (split_line[0] == 'min:' or split_line[0] == 'max:'):
					split_line_idx = 1
					#while split_line[split_line_idx][0] != ';':
					while len(split_line) > split_line_idx:
						mod = convertStr(split_line[split_line_idx] )
						if VarMap.has_key(split_line[split_line_idx + 1]  ):
							VarMap[split_line[split_line_idx + 1]] = VarMap[split_line[split_line_idx + 1]] + mod
						else:
							VarMap[split_line[split_line_idx + 1]] = mod
						split_line_idx = split_line_idx + 2
					OBJ_empty = ''
					if split_line[0] == 'min:':
						OBJ = OBJ + 'Minimize\n' + ' obj: '
						OBJ_empty = OBJ_empty + 'Minimize\n' + ' obj: '
					else:
						OBJ = OBJ + 'Maximize\n' + ' obj: '
						OBJ_empty = OBJ_empty + 'Maximize\n' + ' obj: '
					for var in VarMap.keys():
						if VarMap[ var ] != 0:
							VarSet.add( var )
							if len(OBJ_empty) > 500:
								OBJ = OBJ + '\n '
								OBJ_empty = ''
							if VarMap[ var ] > 0:
								OBJ = OBJ + ' + ' + str(VarMap[var]) + ' ' + var
								OBJ_empty = OBJ_empty + ' + ' + str(VarMap[var]) + ' ' + var
							else:
								OBJ = OBJ + ' - ' + str( 0 - VarMap[var] ) + ' ' + var
								OBJ_empty = OBJ_empty + ' - ' + str( 0 - VarMap[var] ) + ' ' + var
				else:
					while split_line[split_line_idx][0] == '+' or split_line[split_line_idx][0] == '-':
						mod = convertStr(split_line[split_line_idx] )
						if VarMap.has_key(split_line[split_line_idx + 1]  ):
							VarMap[split_line[split_line_idx + 1]] = VarMap[split_line[split_line_idx + 1]] + mod
						else:
							VarMap[split_line[split_line_idx + 1]] = mod
						split_line_idx = split_line_idx + 2
					# modified constraint 
					cons_mod = ''
					cons_mod_empty = ''
					for var in VarMap.keys():
						if VarMap[ var ] != 0:
							VarSet.add( var )
							if len( cons_mod_empty ) > 500:
								cons_mod = cons_mod + '\n '
								cons_mod_empty = ''
							if VarMap[ var ] > 0:
								cons_mod = cons_mod + '+ ' + str(VarMap[var]) + ' ' + var + ' '
								cons_mod_empty = cons_mod_empty + '+ ' + str(VarMap[var]) + ' ' + var + ' '
							else:
								cons_mod = cons_mod + '- ' + str( 0 - VarMap[var] ) + ' ' + var + ' '
								cons_mod_empty = cons_mod_empty + '- ' + str( 0 - VarMap[var] ) + ' ' + var + ' '
					cons_mod = cons_mod + ' ' + split_line[split_line_idx] + ' ' + split_line[split_line_idx + 1]
					ConstraintSet.add( cons_mod )
	return OBJ, ConstraintSet, VarSet


if __name__ == '__main__':
	InFileName = sys.argv[1]
	(OBJ, ConstraintSet, VarSet) = ReadOPB(InFileName)
	# print CPLEX 
	print OBJ
	print 'Subject To'
	cons_count = 1
	for cons in ConstraintSet:
		print ' c' + str(cons_count) + ': ' + cons
		cons_count = cons_count + 1
	print 'Bounds'
	for var in VarSet:
		print ' 0 <= ' + var + ' <= 1 '
	print 'Binary'
	bin = ''
	bin_empty = ''
	for var in VarSet:
		if len( bin_empty ) > 500:
			bin_empty = ''
			bin = bin + '\n '
		bin = bin + var + ' '
		bin_empty = bin_empty + var + ' '
	print ' '+ bin
	print 'End'
