#!/bin/bash
#bash script for mints with PBS4

solver="$1"
base_con_builder=$MINTS/exe/generate_opb.pueblo.exe
next_con_builder=$MINTS/exe/build_next_constraint.exe
pbs_parser=$MINTS/exe/glppb_parser.exe
timeout_limit="$2"
#var_num="$9"
#batch=""

#Read PRIORITY file form stdin
pri_all=0
while read batch_file
do
	pri_all=$((pri_all+1))
	#generate base opb constraint file
	$base_con_builder input_opb_$pri_all $batch_file
	read var_num < $batch_file
done

rm -f solver_output_*

for (( pri=1; pri<=pri_all; pri=pri+1))
do
	if [ $pri == 1 ]
	then
		$next_con_builder input_opb_$pri opb_crit_$pri.opb $var_num 
		timeout -9 $timeout_limit $solver opb_crit_$pri.opb > solver_output_$pri
		$pbs_parser solver_output_$pri opb_crit_$pri.opb opb_new_cons_val_$pri opb_new_cons_$pri
		if [ $? != '0' ]; then
			echo $pri-th criterion not met.
			exit $pri
		fi	
	else
		pri_1=$(($pri-1))
		$next_con_builder input_opb_$pri opb_crit_$pri.opb $var_num  opb_crit_$pri_1.opb opb_new_cons_$pri_1
		timeout -9 $timeout_limit $solver opb_crit_$pri.opb > solver_output_$pri
		$pbs_parser solver_output_$pri opb_crit_$pri.opb opb_new_cons_val_$pri opb_new_cons_$pri
		if [ $? != '0' ]; then
			echo $pri-th criterion not met.
			exit $pri
		fi
	fi
done

rm -f ./opb_new_cons_*
rm -f ./opb_new_cons_val_*
